unit UtilsU;

interface

Type
   // Kept the S in the name here to avoid conflicts with Windows.TPoint
   TSPoint = record
      x: Double;
      y: Double;
   end;

function RandInt(x, y: Integer): Integer;
function RandBool: Boolean;
function RandFloat: Double;
function RandClamped: Double;

procedure Clamp(var arg: Double; min, max: Double);

implementation

uses SysUtils;

function RandInt(x, y: Integer): Integer;
begin
   Result := Random(y - x) + x;
end;

function RandBool: Boolean;
begin
   Result := RandInt(0, 1) = 1;
end;

function RandFloat: Double;
begin
   Result := Random;
end;

function RandClamped: Double;
begin
   Result := RandFloat - RandFloat;
end;

procedure Clamp(var arg: Double; min, max: Double);
begin
   if arg < min then
      arg := min;
   if arg > max then
      arg := max;
end;

initialization
   Randomize;

end.
